local background = {}

function background:init(w,h)
  self.all = {}
  self.w = w
  self.h = h
  for i=1,400 do
    self:spawn()
  end
end

function background:spawn()
  local star = {}
  star.x = math.random(0,self.w)
  star.y = math.random(0,self.h)
  star.duration = math.random(100,500)/100
  star.timer = star.duration
  table.insert(self.all, star)
  return star
end

function background:update(camera, dt)
  for i=#self.all,1,-1 do
    local star = self.all[i]
    --star.x = star.x - camera.x
    --star.y = star.y - camera.y
    star.timer = star.timer - dt
    if star.timer < 0 then      
      star.x = math.random(0,self.w/camera.scale) + camera.x
      star.y = math.random(0,self.h/camera.scale) + camera.y
      star.duration = math.random(100,500)/100
      star.timer = star.duration
    end
  end
end

function background:draw(camera)
  for i=1,#self.all do
    local star = self.all[i]
    local angle = (star.duration - star.timer)/star.duration * math.pi
    local color = {255,255,200,255*math.sin(angle)*math.sin(angle)}
    love.graphics.setColor(color)
    love.graphics.points(star.x, star.y)
  end
end

return background