local physics = {}

function physics:init(cst)
  self.gravitationCst = cst or 1
end

function physics:gravity(a,b,dt,bothSide)  
  -- newtons force calcul
  local dx = a.x - b.x
  local dy = a.y - b.y
  local angle = math.atan2(dy,dx)
  local distance = math.sqrt(dx*dx + dy*dy)
  local coef = self.gravitationCst
  if distance < a.r + b.r then
    return true
  end
  local pow = 2
  local f = coef * math.pow(a.m,pow) * math.pow(b.m,pow) / (distance * distance)
  -- acceleration = force / mass (which is our radius in that case)
  local aAcc = f / a.m
  local bAcc = f / b.m
  a.vx = a.vx - aAcc * math.cos(angle) * dt
  a.vy = a.vy - aAcc * math.sin(angle) * dt
  if bothSide == true then
    b.vx = b.vx + bAcc * math.cos(angle) * dt
    b.vy = b.vy + bAcc * math.sin(angle) * dt
  end
  return false
end

return physics